//////////////////////////////////////////////////////////////
function isTargetBlank(inTarget)
{
	return (inTarget && ("_blank" == inTarget || "blank" == inTarget));
}

function isTargetSelf(inTarget)
{
	return (!inTarget || "" ==inTarget || "_self" == inTarget || 
				"self" == inTarget);
}

function isTargetParent(inTarget)
{
	return (inTarget && ("_parent" == inTarget || "parent" == inTarget));
}

function isTargetTop(inTarget)
{
	return (inTarget && ("_top" == inTarget || "top" == inTarget));
}

function shouldProcessTarget(inTarget, inProcessSelfTarget, 
			inProcessParentTarget, inProcessTopTarget)
{
	return isTargetBlank(inTarget) || 
				inProcessSelfTarget && isTargetSelf(inTarget) || 
				inProcessParentTarget && isTargetParent(inTarget) || 
				inProcessTopTarget && isTargetTop(inTarget);
}
//////////////////////////////////////////////////////////////
function modifyURL(inURL)
{
	if (inURL.match(/GBOpenRequest1AEB804F2F8E/) || inURL.match(/^javascript:/) ||
				inURL.match(/^mailto:/) || inURL.match(/^tel:/) || inURL.match(/^sms:/))
	{
		return inURL;
	}
	return inURL + (inURL.match(/#/) ? "_GBOpenRequest1AEB804F2F8E" : 
				"#GBOpenRequest1AEB804F2F8E");
}

//////////////////////////////////////////////////////////////
function ProcessTargetElement(inElement, inProcessSelfTarget, 
			inProcessParentTarget, inProcessTopTarget)
{
	if (inElement.form)
	{
		if (shouldProcessTarget(inElement.form.target, inProcessSelfTarget, 
					inProcessParentTarget, inProcessTopTarget))
		{
			inElement.form.target = "";
			inElement.form.action = modifyURL(inElement.form.action);
		}
	}
	else
	{
		while (inElement)
		{
			if (inElement.href)
			{
				if (shouldProcessTarget(inElement.target, inProcessSelfTarget, 
							inProcessParentTarget, inProcessTopTarget))
				{
					inElement.target = "";
					inElement.href = modifyURL(inElement.href);
					if (inElement.getAttribute("dirtyhref"))
					{
						inElement.setAttribute("dirtyhref", inElement.href);
					}
				}
				break;
			}
			inElement = inElement.parentNode;
		}
	}
}

//////////////////////////////////////////////////////////////
function restoreURL(inURL)
{
	if (!inURL.match(/GBOpenRequest1AEB804F2F8E/))
	{
		return inURL;
	}

	return inURL.substring(0, inURL.length - "GBOpenRequest1AEB804F2F8E".length - 1);
}

function GBEventPreventDefault()
{
	var theElement = this.target;
	while (theElement)
	{
		if (theElement.href)
		{
			theElement.href = restoreURL(theElement.href);
			break;
		}
		theElement = theElement.parentNode;
	}
	
	this.preventDefault_Original();
}

function GBModifyEvent(anEvent)
{
	anEvent.preventDefault_Original = anEvent.preventDefault;
	anEvent.preventDefault = GBEventPreventDefault;
}
//////////////////////////////////////////////////////////////
function GBFrameEventListener(anEvent)
{
	if (anEvent && anEvent.target)
	{
		GBModifyEvent(anEvent);
		ProcessTargetElement(anEvent.target, false, true, true);
	}	
}
function GBMainDocumentEventListener(anEvent)
{
	if (anEvent && anEvent.target)
	{
		GBModifyEvent(anEvent);
		ProcessTargetElement(anEvent.target, true, true, true);
	}	
}

//////////////////////////////////////////////////////////////
function adjustFrame(inFrame)
{
	inFrame.contentDocument.addEventListener("click", GBFrameEventListener, true);
}
function adjustDocumentFrames(inFrameTag)
{
	var theFrames = document.getElementsByTagName(inFrameTag);
	var theFramesLength = theFrames.length;
	for (var i = 0; i < theFramesLength; i++)
	{
		adjustFrame(theFrames[i]);
	}
}
//////////////////////////////////////////////////////////////
function preprocessDocument()
{
	document.addEventListener("click", GBMainDocumentEventListener, true);
	
	adjustDocumentFrames("iframe");
	adjustDocumentFrames("frame");
}
//////////////////////////////////////////////////////////////
function preprocessOpenWindow()
{
	window.open = function(inURL)
	{
		window.location.assign(modifyURL(inURL));
	}
	
	for (var i = 0; i < frames.length; i++) 
	{ 
		frames[i].open = function(inURL)
		{
			window.location.assign(modifyURL(inURL));
		}
	}
}
////////////////////////////////////////////////////////////////////////////////
preprocessOpenWindow();
preprocessDocument();